# coding: utf-8

"""
    HAProxy Data Plane API

    API for editing and managing haproxy instances. Provides process information, configuration management, haproxy stats and logs.   # noqa: E501

    OpenAPI spec version: 2.7
    Contact: support@haproxy.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from dataplaneapi.api_client import ApiClient


class ACLRuntimeApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def add_payload_runtime_acl(self, body, acl_id, **kwargs):  # noqa: E501
        """Add a new ACL payload  # noqa: E501

        Adds a new ACL payload.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_payload_runtime_acl(body, acl_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param list[AclFileEntry] body: (required)
        :param str acl_id: ACL ID (required)
        :return: AclFilesEntries
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_payload_runtime_acl_with_http_info(body, acl_id, **kwargs)  # noqa: E501
        else:
            (data) = self.add_payload_runtime_acl_with_http_info(body, acl_id, **kwargs)  # noqa: E501
            return data

    def add_payload_runtime_acl_with_http_info(self, body, acl_id, **kwargs):  # noqa: E501
        """Add a new ACL payload  # noqa: E501

        Adds a new ACL payload.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_payload_runtime_acl_with_http_info(body, acl_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param list[AclFileEntry] body: (required)
        :param str acl_id: ACL ID (required)
        :return: AclFilesEntries
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'acl_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_payload_runtime_acl" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `add_payload_runtime_acl`")  # noqa: E501
        # verify the required parameter 'acl_id' is set
        if ('acl_id' not in params or
                params['acl_id'] is None):
            raise ValueError("Missing the required parameter `acl_id` when calling `add_payload_runtime_acl`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'acl_id' in params:
            query_params.append(('acl_id', params['acl_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic_auth']  # noqa: E501

        return self.api_client.call_api(
            '/services/haproxy/runtime/acl_file_entries', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='AclFilesEntries',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def services_haproxy_runtime_acl_file_entries_get(self, acl_id, **kwargs):  # noqa: E501
        """Return an ACL entries  # noqa: E501

        Returns an ACL runtime setting using the runtime socket.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.services_haproxy_runtime_acl_file_entries_get(acl_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str acl_id: ACL ID (required)
        :return: AclFilesEntries
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.services_haproxy_runtime_acl_file_entries_get_with_http_info(acl_id, **kwargs)  # noqa: E501
        else:
            (data) = self.services_haproxy_runtime_acl_file_entries_get_with_http_info(acl_id, **kwargs)  # noqa: E501
            return data

    def services_haproxy_runtime_acl_file_entries_get_with_http_info(self, acl_id, **kwargs):  # noqa: E501
        """Return an ACL entries  # noqa: E501

        Returns an ACL runtime setting using the runtime socket.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.services_haproxy_runtime_acl_file_entries_get_with_http_info(acl_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str acl_id: ACL ID (required)
        :return: AclFilesEntries
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['acl_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method services_haproxy_runtime_acl_file_entries_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'acl_id' is set
        if ('acl_id' not in params or
                params['acl_id'] is None):
            raise ValueError("Missing the required parameter `acl_id` when calling `services_haproxy_runtime_acl_file_entries_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'acl_id' in params:
            query_params.append(('acl_id', params['acl_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic_auth']  # noqa: E501

        return self.api_client.call_api(
            '/services/haproxy/runtime/acl_file_entries', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='AclFilesEntries',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def services_haproxy_runtime_acl_file_entries_id_delete(self, acl_id, id, **kwargs):  # noqa: E501
        """Delete an ACL entry  # noqa: E501

        Deletes the entry from the ACL by its value using the runtime socket.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.services_haproxy_runtime_acl_file_entries_id_delete(acl_id, id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str acl_id: ACL ID (required)
        :param str id: File entry ID (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.services_haproxy_runtime_acl_file_entries_id_delete_with_http_info(acl_id, id, **kwargs)  # noqa: E501
        else:
            (data) = self.services_haproxy_runtime_acl_file_entries_id_delete_with_http_info(acl_id, id, **kwargs)  # noqa: E501
            return data

    def services_haproxy_runtime_acl_file_entries_id_delete_with_http_info(self, acl_id, id, **kwargs):  # noqa: E501
        """Delete an ACL entry  # noqa: E501

        Deletes the entry from the ACL by its value using the runtime socket.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.services_haproxy_runtime_acl_file_entries_id_delete_with_http_info(acl_id, id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str acl_id: ACL ID (required)
        :param str id: File entry ID (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['acl_id', 'id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method services_haproxy_runtime_acl_file_entries_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'acl_id' is set
        if ('acl_id' not in params or
                params['acl_id'] is None):
            raise ValueError("Missing the required parameter `acl_id` when calling `services_haproxy_runtime_acl_file_entries_id_delete`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `services_haproxy_runtime_acl_file_entries_id_delete`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []
        if 'acl_id' in params:
            query_params.append(('acl_id', params['acl_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic_auth']  # noqa: E501

        return self.api_client.call_api(
            '/services/haproxy/runtime/acl_file_entries/{id}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def services_haproxy_runtime_acl_file_entries_id_get(self, acl_id, id, **kwargs):  # noqa: E501
        """Return an ACL entry  # noqa: E501

        Returns the ACL entry by its ID using the runtime socket.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.services_haproxy_runtime_acl_file_entries_id_get(acl_id, id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str acl_id: ACL ID (required)
        :param str id: File entry ID (required)
        :return: AclFileEntry
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.services_haproxy_runtime_acl_file_entries_id_get_with_http_info(acl_id, id, **kwargs)  # noqa: E501
        else:
            (data) = self.services_haproxy_runtime_acl_file_entries_id_get_with_http_info(acl_id, id, **kwargs)  # noqa: E501
            return data

    def services_haproxy_runtime_acl_file_entries_id_get_with_http_info(self, acl_id, id, **kwargs):  # noqa: E501
        """Return an ACL entry  # noqa: E501

        Returns the ACL entry by its ID using the runtime socket.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.services_haproxy_runtime_acl_file_entries_id_get_with_http_info(acl_id, id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str acl_id: ACL ID (required)
        :param str id: File entry ID (required)
        :return: AclFileEntry
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['acl_id', 'id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method services_haproxy_runtime_acl_file_entries_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'acl_id' is set
        if ('acl_id' not in params or
                params['acl_id'] is None):
            raise ValueError("Missing the required parameter `acl_id` when calling `services_haproxy_runtime_acl_file_entries_id_get`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `services_haproxy_runtime_acl_file_entries_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []
        if 'acl_id' in params:
            query_params.append(('acl_id', params['acl_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic_auth']  # noqa: E501

        return self.api_client.call_api(
            '/services/haproxy/runtime/acl_file_entries/{id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='AclFileEntry',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def services_haproxy_runtime_acl_file_entries_post(self, body, acl_id, **kwargs):  # noqa: E501
        """Add entry to an ACL file  # noqa: E501

        Adds an entry into the ACL file using the runtime socket.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.services_haproxy_runtime_acl_file_entries_post(body, acl_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param AclFileEntry body: (required)
        :param str acl_id: ACL ID (required)
        :return: AclFileEntry
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.services_haproxy_runtime_acl_file_entries_post_with_http_info(body, acl_id, **kwargs)  # noqa: E501
        else:
            (data) = self.services_haproxy_runtime_acl_file_entries_post_with_http_info(body, acl_id, **kwargs)  # noqa: E501
            return data

    def services_haproxy_runtime_acl_file_entries_post_with_http_info(self, body, acl_id, **kwargs):  # noqa: E501
        """Add entry to an ACL file  # noqa: E501

        Adds an entry into the ACL file using the runtime socket.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.services_haproxy_runtime_acl_file_entries_post_with_http_info(body, acl_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param AclFileEntry body: (required)
        :param str acl_id: ACL ID (required)
        :return: AclFileEntry
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'acl_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method services_haproxy_runtime_acl_file_entries_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `services_haproxy_runtime_acl_file_entries_post`")  # noqa: E501
        # verify the required parameter 'acl_id' is set
        if ('acl_id' not in params or
                params['acl_id'] is None):
            raise ValueError("Missing the required parameter `acl_id` when calling `services_haproxy_runtime_acl_file_entries_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'acl_id' in params:
            query_params.append(('acl_id', params['acl_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic_auth']  # noqa: E501

        return self.api_client.call_api(
            '/services/haproxy/runtime/acl_file_entries', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='AclFileEntry',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def services_haproxy_runtime_acls_get(self, **kwargs):  # noqa: E501
        """Return an array of all ACL files  # noqa: E501

        Returns all ACL files using the runtime socket.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.services_haproxy_runtime_acls_get(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: AclFiles
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.services_haproxy_runtime_acls_get_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.services_haproxy_runtime_acls_get_with_http_info(**kwargs)  # noqa: E501
            return data

    def services_haproxy_runtime_acls_get_with_http_info(self, **kwargs):  # noqa: E501
        """Return an array of all ACL files  # noqa: E501

        Returns all ACL files using the runtime socket.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.services_haproxy_runtime_acls_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: AclFiles
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method services_haproxy_runtime_acls_get" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic_auth']  # noqa: E501

        return self.api_client.call_api(
            '/services/haproxy/runtime/acls', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='AclFiles',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def services_haproxy_runtime_acls_id_get(self, id, **kwargs):  # noqa: E501
        """Return an ACL file  # noqa: E501

        Returns an ACL file by id using the runtime socket.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.services_haproxy_runtime_acls_id_get(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: ACL file entry ID (required)
        :return: AclFile
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.services_haproxy_runtime_acls_id_get_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.services_haproxy_runtime_acls_id_get_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def services_haproxy_runtime_acls_id_get_with_http_info(self, id, **kwargs):  # noqa: E501
        """Return an ACL file  # noqa: E501

        Returns an ACL file by id using the runtime socket.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.services_haproxy_runtime_acls_id_get_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: ACL file entry ID (required)
        :return: AclFile
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method services_haproxy_runtime_acls_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `services_haproxy_runtime_acls_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic_auth']  # noqa: E501

        return self.api_client.call_api(
            '/services/haproxy/runtime/acls/{id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='AclFile',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
