# coding: utf-8

"""
    HAProxy Data Plane API

    API for editing and managing haproxy instances. Provides process information, configuration management, haproxy stats and logs.   # noqa: E501

    OpenAPI spec version: 2.7
    Contact: support@haproxy.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from dataplaneapi.api_client import ApiClient


class DgramBindApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_dgram_bind(self, body, log_forward, **kwargs):  # noqa: E501
        """Add a new dgram bind  # noqa: E501

        Adds a new dgram bind in the specified log forward in the configuration file.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_dgram_bind(body, log_forward, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DgramBind body: (required)
        :param str log_forward: Parent log forward name (required)
        :param str transaction_id: ID of the transaction where we want to add the operation. Cannot be used when version is specified.
        :param int version: Version used for checking configuration version. Cannot be used when transaction is specified, transaction has it's own version.
        :param bool force_reload: If set, do a force reload, do not wait for the configured reload-delay. Cannot be used when transaction is specified, as changes in transaction are not applied directly to configuration.
        :return: DgramBind
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_dgram_bind_with_http_info(body, log_forward, **kwargs)  # noqa: E501
        else:
            (data) = self.create_dgram_bind_with_http_info(body, log_forward, **kwargs)  # noqa: E501
            return data

    def create_dgram_bind_with_http_info(self, body, log_forward, **kwargs):  # noqa: E501
        """Add a new dgram bind  # noqa: E501

        Adds a new dgram bind in the specified log forward in the configuration file.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_dgram_bind_with_http_info(body, log_forward, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DgramBind body: (required)
        :param str log_forward: Parent log forward name (required)
        :param str transaction_id: ID of the transaction where we want to add the operation. Cannot be used when version is specified.
        :param int version: Version used for checking configuration version. Cannot be used when transaction is specified, transaction has it's own version.
        :param bool force_reload: If set, do a force reload, do not wait for the configured reload-delay. Cannot be used when transaction is specified, as changes in transaction are not applied directly to configuration.
        :return: DgramBind
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'log_forward', 'transaction_id', 'version', 'force_reload']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_dgram_bind" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_dgram_bind`")  # noqa: E501
        # verify the required parameter 'log_forward' is set
        if ('log_forward' not in params or
                params['log_forward'] is None):
            raise ValueError("Missing the required parameter `log_forward` when calling `create_dgram_bind`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'log_forward' in params:
            query_params.append(('log_forward', params['log_forward']))  # noqa: E501
        if 'transaction_id' in params:
            query_params.append(('transaction_id', params['transaction_id']))  # noqa: E501
        if 'version' in params:
            query_params.append(('version', params['version']))  # noqa: E501
        if 'force_reload' in params:
            query_params.append(('force_reload', params['force_reload']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic_auth']  # noqa: E501

        return self.api_client.call_api(
            '/services/haproxy/configuration/dgram_binds', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DgramBind',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_dgram_bind(self, name, log_forward, **kwargs):  # noqa: E501
        """Delete a dgram bind  # noqa: E501

        Deletes a dgram bind configuration by it's name in the specified log forward.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_dgram_bind(name, log_forward, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str name: Bind name (required)
        :param str log_forward: Parent log forward name (required)
        :param str transaction_id: ID of the transaction where we want to add the operation. Cannot be used when version is specified.
        :param int version: Version used for checking configuration version. Cannot be used when transaction is specified, transaction has it's own version.
        :param bool force_reload: If set, do a force reload, do not wait for the configured reload-delay. Cannot be used when transaction is specified, as changes in transaction are not applied directly to configuration.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_dgram_bind_with_http_info(name, log_forward, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_dgram_bind_with_http_info(name, log_forward, **kwargs)  # noqa: E501
            return data

    def delete_dgram_bind_with_http_info(self, name, log_forward, **kwargs):  # noqa: E501
        """Delete a dgram bind  # noqa: E501

        Deletes a dgram bind configuration by it's name in the specified log forward.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_dgram_bind_with_http_info(name, log_forward, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str name: Bind name (required)
        :param str log_forward: Parent log forward name (required)
        :param str transaction_id: ID of the transaction where we want to add the operation. Cannot be used when version is specified.
        :param int version: Version used for checking configuration version. Cannot be used when transaction is specified, transaction has it's own version.
        :param bool force_reload: If set, do a force reload, do not wait for the configured reload-delay. Cannot be used when transaction is specified, as changes in transaction are not applied directly to configuration.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['name', 'log_forward', 'transaction_id', 'version', 'force_reload']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_dgram_bind" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'name' is set
        if ('name' not in params or
                params['name'] is None):
            raise ValueError("Missing the required parameter `name` when calling `delete_dgram_bind`")  # noqa: E501
        # verify the required parameter 'log_forward' is set
        if ('log_forward' not in params or
                params['log_forward'] is None):
            raise ValueError("Missing the required parameter `log_forward` when calling `delete_dgram_bind`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'name' in params:
            path_params['name'] = params['name']  # noqa: E501

        query_params = []
        if 'log_forward' in params:
            query_params.append(('log_forward', params['log_forward']))  # noqa: E501
        if 'transaction_id' in params:
            query_params.append(('transaction_id', params['transaction_id']))  # noqa: E501
        if 'version' in params:
            query_params.append(('version', params['version']))  # noqa: E501
        if 'force_reload' in params:
            query_params.append(('force_reload', params['force_reload']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic_auth']  # noqa: E501

        return self.api_client.call_api(
            '/services/haproxy/configuration/dgram_binds/{name}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dgram_bind(self, name, log_forward, **kwargs):  # noqa: E501
        """Return one dgram bind  # noqa: E501

        Returns one dgram bind configuration by it's name in the specified log forward.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dgram_bind(name, log_forward, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str name: Bind name (required)
        :param str log_forward: Parent log forward name (required)
        :param str transaction_id: ID of the transaction where we want to add the operation. Cannot be used when version is specified.
        :return: InlineResponse20018
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dgram_bind_with_http_info(name, log_forward, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dgram_bind_with_http_info(name, log_forward, **kwargs)  # noqa: E501
            return data

    def get_dgram_bind_with_http_info(self, name, log_forward, **kwargs):  # noqa: E501
        """Return one dgram bind  # noqa: E501

        Returns one dgram bind configuration by it's name in the specified log forward.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dgram_bind_with_http_info(name, log_forward, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str name: Bind name (required)
        :param str log_forward: Parent log forward name (required)
        :param str transaction_id: ID of the transaction where we want to add the operation. Cannot be used when version is specified.
        :return: InlineResponse20018
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['name', 'log_forward', 'transaction_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dgram_bind" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'name' is set
        if ('name' not in params or
                params['name'] is None):
            raise ValueError("Missing the required parameter `name` when calling `get_dgram_bind`")  # noqa: E501
        # verify the required parameter 'log_forward' is set
        if ('log_forward' not in params or
                params['log_forward'] is None):
            raise ValueError("Missing the required parameter `log_forward` when calling `get_dgram_bind`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'name' in params:
            path_params['name'] = params['name']  # noqa: E501

        query_params = []
        if 'log_forward' in params:
            query_params.append(('log_forward', params['log_forward']))  # noqa: E501
        if 'transaction_id' in params:
            query_params.append(('transaction_id', params['transaction_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic_auth']  # noqa: E501

        return self.api_client.call_api(
            '/services/haproxy/configuration/dgram_binds/{name}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20018',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dgram_binds(self, log_forward, **kwargs):  # noqa: E501
        """Return an array of dgram binds  # noqa: E501

        Returns an array of all dgram binds that are configured in specified log forward.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dgram_binds(log_forward, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str log_forward: Parent log forward name (required)
        :param str transaction_id: ID of the transaction where we want to add the operation. Cannot be used when version is specified.
        :return: InlineResponse20017
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dgram_binds_with_http_info(log_forward, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dgram_binds_with_http_info(log_forward, **kwargs)  # noqa: E501
            return data

    def get_dgram_binds_with_http_info(self, log_forward, **kwargs):  # noqa: E501
        """Return an array of dgram binds  # noqa: E501

        Returns an array of all dgram binds that are configured in specified log forward.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dgram_binds_with_http_info(log_forward, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str log_forward: Parent log forward name (required)
        :param str transaction_id: ID of the transaction where we want to add the operation. Cannot be used when version is specified.
        :return: InlineResponse20017
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['log_forward', 'transaction_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dgram_binds" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'log_forward' is set
        if ('log_forward' not in params or
                params['log_forward'] is None):
            raise ValueError("Missing the required parameter `log_forward` when calling `get_dgram_binds`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'log_forward' in params:
            query_params.append(('log_forward', params['log_forward']))  # noqa: E501
        if 'transaction_id' in params:
            query_params.append(('transaction_id', params['transaction_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic_auth']  # noqa: E501

        return self.api_client.call_api(
            '/services/haproxy/configuration/dgram_binds', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20017',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def replace_dgram_bind(self, body, log_forward, name, **kwargs):  # noqa: E501
        """Replace a dgram bind  # noqa: E501

        Replaces a dgram bind configuration by it's name in the specified log forward.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.replace_dgram_bind(body, log_forward, name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DgramBind body: (required)
        :param str log_forward: Parent log forward name (required)
        :param str name: Bind name (required)
        :param str transaction_id: ID of the transaction where we want to add the operation. Cannot be used when version is specified.
        :param int version: Version used for checking configuration version. Cannot be used when transaction is specified, transaction has it's own version.
        :param bool force_reload: If set, do a force reload, do not wait for the configured reload-delay. Cannot be used when transaction is specified, as changes in transaction are not applied directly to configuration.
        :return: DgramBind
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.replace_dgram_bind_with_http_info(body, log_forward, name, **kwargs)  # noqa: E501
        else:
            (data) = self.replace_dgram_bind_with_http_info(body, log_forward, name, **kwargs)  # noqa: E501
            return data

    def replace_dgram_bind_with_http_info(self, body, log_forward, name, **kwargs):  # noqa: E501
        """Replace a dgram bind  # noqa: E501

        Replaces a dgram bind configuration by it's name in the specified log forward.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.replace_dgram_bind_with_http_info(body, log_forward, name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DgramBind body: (required)
        :param str log_forward: Parent log forward name (required)
        :param str name: Bind name (required)
        :param str transaction_id: ID of the transaction where we want to add the operation. Cannot be used when version is specified.
        :param int version: Version used for checking configuration version. Cannot be used when transaction is specified, transaction has it's own version.
        :param bool force_reload: If set, do a force reload, do not wait for the configured reload-delay. Cannot be used when transaction is specified, as changes in transaction are not applied directly to configuration.
        :return: DgramBind
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'log_forward', 'name', 'transaction_id', 'version', 'force_reload']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method replace_dgram_bind" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `replace_dgram_bind`")  # noqa: E501
        # verify the required parameter 'log_forward' is set
        if ('log_forward' not in params or
                params['log_forward'] is None):
            raise ValueError("Missing the required parameter `log_forward` when calling `replace_dgram_bind`")  # noqa: E501
        # verify the required parameter 'name' is set
        if ('name' not in params or
                params['name'] is None):
            raise ValueError("Missing the required parameter `name` when calling `replace_dgram_bind`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'name' in params:
            path_params['name'] = params['name']  # noqa: E501

        query_params = []
        if 'log_forward' in params:
            query_params.append(('log_forward', params['log_forward']))  # noqa: E501
        if 'transaction_id' in params:
            query_params.append(('transaction_id', params['transaction_id']))  # noqa: E501
        if 'version' in params:
            query_params.append(('version', params['version']))  # noqa: E501
        if 'force_reload' in params:
            query_params.append(('force_reload', params['force_reload']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basic_auth']  # noqa: E501

        return self.api_client.call_api(
            '/services/haproxy/configuration/dgram_binds/{name}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DgramBind',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
