# coding: utf-8

"""
    HAProxy Data Plane API

    API for editing and managing haproxy instances. Provides process information, configuration management, haproxy stats and logs.   # noqa: E501

    OpenAPI spec version: 2.7
    Contact: support@haproxy.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from dataplaneapi.models.bind_params import BindParams  # noqa: F401,E501

class Bind(BindParams):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'address': 'str',
        'port': 'int',
        'port_range_end': 'int'
    }
    if hasattr(BindParams, "swagger_types"):
        swagger_types.update(BindParams.swagger_types)

    attribute_map = {
        'address': 'address',
        'port': 'port',
        'port_range_end': 'port-range-end'
    }
    if hasattr(BindParams, "attribute_map"):
        attribute_map.update(BindParams.attribute_map)

    def __init__(self, address=None, port=None, port_range_end=None, *args, **kwargs):  # noqa: E501
        """Bind - a model defined in Swagger"""  # noqa: E501
        self._address = None
        self._port = None
        self._port_range_end = None
        self.discriminator = None
        if address is not None:
            self.address = address
        if port is not None:
            self.port = port
        if port_range_end is not None:
            self.port_range_end = port_range_end
        BindParams.__init__(self, *args, **kwargs)

    @property
    def address(self):
        """Gets the address of this Bind.  # noqa: E501


        :return: The address of this Bind.  # noqa: E501
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this Bind.


        :param address: The address of this Bind.  # noqa: E501
        :type: str
        """

        self._address = address

    @property
    def port(self):
        """Gets the port of this Bind.  # noqa: E501


        :return: The port of this Bind.  # noqa: E501
        :rtype: int
        """
        return self._port

    @port.setter
    def port(self, port):
        """Sets the port of this Bind.


        :param port: The port of this Bind.  # noqa: E501
        :type: int
        """

        self._port = port

    @property
    def port_range_end(self):
        """Gets the port_range_end of this Bind.  # noqa: E501


        :return: The port_range_end of this Bind.  # noqa: E501
        :rtype: int
        """
        return self._port_range_end

    @port_range_end.setter
    def port_range_end(self, port_range_end):
        """Sets the port_range_end of this Bind.


        :param port_range_end: The port_range_end of this Bind.  # noqa: E501
        :type: int
        """

        self._port_range_end = port_range_end

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Bind, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Bind):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
