# coding: utf-8

"""
    HAProxy Data Plane API

    API for editing and managing haproxy instances. Provides process information, configuration management, haproxy stats and logs.   # noqa: E501

    OpenAPI spec version: 2.7
    Contact: support@haproxy.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ClusterControllerInformationLogTargets(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'address': 'str',
        'log_format': 'str',
        'port': 'int',
        'protocol': 'str'
    }

    attribute_map = {
        'address': 'address',
        'log_format': 'log_format',
        'port': 'port',
        'protocol': 'protocol'
    }

    def __init__(self, address=None, log_format=None, port=None, protocol=None):  # noqa: E501
        """ClusterControllerInformationLogTargets - a model defined in Swagger"""  # noqa: E501
        self._address = None
        self._log_format = None
        self._port = None
        self._protocol = None
        self.discriminator = None
        self.address = address
        if log_format is not None:
            self.log_format = log_format
        self.port = port
        self.protocol = protocol

    @property
    def address(self):
        """Gets the address of this ClusterControllerInformationLogTargets.  # noqa: E501


        :return: The address of this ClusterControllerInformationLogTargets.  # noqa: E501
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this ClusterControllerInformationLogTargets.


        :param address: The address of this ClusterControllerInformationLogTargets.  # noqa: E501
        :type: str
        """
        if address is None:
            raise ValueError("Invalid value for `address`, must not be `None`")  # noqa: E501

        self._address = address

    @property
    def log_format(self):
        """Gets the log_format of this ClusterControllerInformationLogTargets.  # noqa: E501


        :return: The log_format of this ClusterControllerInformationLogTargets.  # noqa: E501
        :rtype: str
        """
        return self._log_format

    @log_format.setter
    def log_format(self, log_format):
        """Sets the log_format of this ClusterControllerInformationLogTargets.


        :param log_format: The log_format of this ClusterControllerInformationLogTargets.  # noqa: E501
        :type: str
        """

        self._log_format = log_format

    @property
    def port(self):
        """Gets the port of this ClusterControllerInformationLogTargets.  # noqa: E501


        :return: The port of this ClusterControllerInformationLogTargets.  # noqa: E501
        :rtype: int
        """
        return self._port

    @port.setter
    def port(self, port):
        """Sets the port of this ClusterControllerInformationLogTargets.


        :param port: The port of this ClusterControllerInformationLogTargets.  # noqa: E501
        :type: int
        """
        if port is None:
            raise ValueError("Invalid value for `port`, must not be `None`")  # noqa: E501

        self._port = port

    @property
    def protocol(self):
        """Gets the protocol of this ClusterControllerInformationLogTargets.  # noqa: E501


        :return: The protocol of this ClusterControllerInformationLogTargets.  # noqa: E501
        :rtype: str
        """
        return self._protocol

    @protocol.setter
    def protocol(self, protocol):
        """Sets the protocol of this ClusterControllerInformationLogTargets.


        :param protocol: The protocol of this ClusterControllerInformationLogTargets.  # noqa: E501
        :type: str
        """
        if protocol is None:
            raise ValueError("Invalid value for `protocol`, must not be `None`")  # noqa: E501
        allowed_values = ["tcp", "udp"]  # noqa: E501
        if protocol not in allowed_values:
            raise ValueError(
                "Invalid value for `protocol` ({0}), must be one of {1}"  # noqa: E501
                .format(protocol, allowed_values)
            )

        self._protocol = protocol

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ClusterControllerInformationLogTargets, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ClusterControllerInformationLogTargets):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
