# coding: utf-8

"""
    HAProxy Data Plane API

    API for editing and managing haproxy instances. Provides process information, configuration management, haproxy stats and logs.   # noqa: E501

    OpenAPI spec version: 2.7
    Contact: support@haproxy.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class HashType(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'function': 'str',
        'method': 'str',
        'modifier': 'str'
    }

    attribute_map = {
        'function': 'function',
        'method': 'method',
        'modifier': 'modifier'
    }

    def __init__(self, function=None, method=None, modifier=None):  # noqa: E501
        """HashType - a model defined in Swagger"""  # noqa: E501
        self._function = None
        self._method = None
        self._modifier = None
        self.discriminator = None
        if function is not None:
            self.function = function
        if method is not None:
            self.method = method
        if modifier is not None:
            self.modifier = modifier

    @property
    def function(self):
        """Gets the function of this HashType.  # noqa: E501


        :return: The function of this HashType.  # noqa: E501
        :rtype: str
        """
        return self._function

    @function.setter
    def function(self, function):
        """Sets the function of this HashType.


        :param function: The function of this HashType.  # noqa: E501
        :type: str
        """
        allowed_values = ["sdbm", "djb2", "wt6", "crc32"]  # noqa: E501
        if function not in allowed_values:
            raise ValueError(
                "Invalid value for `function` ({0}), must be one of {1}"  # noqa: E501
                .format(function, allowed_values)
            )

        self._function = function

    @property
    def method(self):
        """Gets the method of this HashType.  # noqa: E501


        :return: The method of this HashType.  # noqa: E501
        :rtype: str
        """
        return self._method

    @method.setter
    def method(self, method):
        """Sets the method of this HashType.


        :param method: The method of this HashType.  # noqa: E501
        :type: str
        """
        allowed_values = ["map-based", "consistent"]  # noqa: E501
        if method not in allowed_values:
            raise ValueError(
                "Invalid value for `method` ({0}), must be one of {1}"  # noqa: E501
                .format(method, allowed_values)
            )

        self._method = method

    @property
    def modifier(self):
        """Gets the modifier of this HashType.  # noqa: E501


        :return: The modifier of this HashType.  # noqa: E501
        :rtype: str
        """
        return self._modifier

    @modifier.setter
    def modifier(self, modifier):
        """Sets the modifier of this HashType.


        :param modifier: The modifier of this HashType.  # noqa: E501
        :type: str
        """
        allowed_values = ["avalanche"]  # noqa: E501
        if modifier not in allowed_values:
            raise ValueError(
                "Invalid value for `modifier` ({0}), must be one of {1}"  # noqa: E501
                .format(modifier, allowed_values)
            )

        self._modifier = modifier

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(HashType, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HashType):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
