# coding: utf-8

"""
    HAProxy Data Plane API

    API for editing and managing haproxy instances. Provides process information, configuration management, haproxy stats and logs.   # noqa: E501

    OpenAPI spec version: 2.7
    Contact: support@haproxy.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class InfoApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'build_date': 'datetime',
        'version': 'str'
    }

    attribute_map = {
        'build_date': 'build_date',
        'version': 'version'
    }

    def __init__(self, build_date=None, version=None):  # noqa: E501
        """InfoApi - a model defined in Swagger"""  # noqa: E501
        self._build_date = None
        self._version = None
        self.discriminator = None
        if build_date is not None:
            self.build_date = build_date
        if version is not None:
            self.version = version

    @property
    def build_date(self):
        """Gets the build_date of this InfoApi.  # noqa: E501

        HAProxy Dataplane API build date  # noqa: E501

        :return: The build_date of this InfoApi.  # noqa: E501
        :rtype: datetime
        """
        return self._build_date

    @build_date.setter
    def build_date(self, build_date):
        """Sets the build_date of this InfoApi.

        HAProxy Dataplane API build date  # noqa: E501

        :param build_date: The build_date of this InfoApi.  # noqa: E501
        :type: datetime
        """

        self._build_date = build_date

    @property
    def version(self):
        """Gets the version of this InfoApi.  # noqa: E501

        HAProxy Dataplane API version string  # noqa: E501

        :return: The version of this InfoApi.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this InfoApi.

        HAProxy Dataplane API version string  # noqa: E501

        :param version: The version of this InfoApi.  # noqa: E501
        :type: str
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InfoApi, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InfoApi):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
