# coding: utf-8

"""
    HAProxy Data Plane API

    API for editing and managing haproxy instances. Provides process information, configuration management, haproxy stats and logs.   # noqa: E501

    OpenAPI spec version: 2.7
    Contact: support@haproxy.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class LogForward(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'backlog': 'int',
        'maxconn': 'int',
        'name': 'str',
        'timeout_client': 'int'
    }

    attribute_map = {
        'backlog': 'backlog',
        'maxconn': 'maxconn',
        'name': 'name',
        'timeout_client': 'timeout_client'
    }

    def __init__(self, backlog=None, maxconn=None, name=None, timeout_client=None):  # noqa: E501
        """LogForward - a model defined in Swagger"""  # noqa: E501
        self._backlog = None
        self._maxconn = None
        self._name = None
        self._timeout_client = None
        self.discriminator = None
        if backlog is not None:
            self.backlog = backlog
        if maxconn is not None:
            self.maxconn = maxconn
        self.name = name
        if timeout_client is not None:
            self.timeout_client = timeout_client

    @property
    def backlog(self):
        """Gets the backlog of this LogForward.  # noqa: E501


        :return: The backlog of this LogForward.  # noqa: E501
        :rtype: int
        """
        return self._backlog

    @backlog.setter
    def backlog(self, backlog):
        """Sets the backlog of this LogForward.


        :param backlog: The backlog of this LogForward.  # noqa: E501
        :type: int
        """

        self._backlog = backlog

    @property
    def maxconn(self):
        """Gets the maxconn of this LogForward.  # noqa: E501


        :return: The maxconn of this LogForward.  # noqa: E501
        :rtype: int
        """
        return self._maxconn

    @maxconn.setter
    def maxconn(self, maxconn):
        """Sets the maxconn of this LogForward.


        :param maxconn: The maxconn of this LogForward.  # noqa: E501
        :type: int
        """

        self._maxconn = maxconn

    @property
    def name(self):
        """Gets the name of this LogForward.  # noqa: E501


        :return: The name of this LogForward.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this LogForward.


        :param name: The name of this LogForward.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def timeout_client(self):
        """Gets the timeout_client of this LogForward.  # noqa: E501


        :return: The timeout_client of this LogForward.  # noqa: E501
        :rtype: int
        """
        return self._timeout_client

    @timeout_client.setter
    def timeout_client(self, timeout_client):
        """Sets the timeout_client of this LogForward.


        :param timeout_client: The timeout_client of this LogForward.  # noqa: E501
        :type: int
        """

        self._timeout_client = timeout_client

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(LogForward, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LogForward):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
