# coding: utf-8

"""
    HAProxy Data Plane API

    API for editing and managing haproxy instances. Provides process information, configuration management, haproxy stats and logs.   # noqa: E501

    OpenAPI spec version: 2.7
    Contact: support@haproxy.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class LogTarget(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'address': 'str',
        'facility': 'str',
        'format': 'str',
        '_global': 'bool',
        'index': 'int',
        'length': 'int',
        'level': 'str',
        'minlevel': 'str',
        'nolog': 'bool',
        'sample_range': 'str',
        'sample_size': 'int'
    }

    attribute_map = {
        'address': 'address',
        'facility': 'facility',
        'format': 'format',
        '_global': 'global',
        'index': 'index',
        'length': 'length',
        'level': 'level',
        'minlevel': 'minlevel',
        'nolog': 'nolog',
        'sample_range': 'sample_range',
        'sample_size': 'sample_size'
    }

    def __init__(self, address=None, facility=None, format=None, _global=None, index=None, length=None, level=None, minlevel=None, nolog=None, sample_range=None, sample_size=None):  # noqa: E501
        """LogTarget - a model defined in Swagger"""  # noqa: E501
        self._address = None
        self._facility = None
        self._format = None
        self.__global = None
        self._index = None
        self._length = None
        self._level = None
        self._minlevel = None
        self._nolog = None
        self._sample_range = None
        self._sample_size = None
        self.discriminator = None
        if address is not None:
            self.address = address
        if facility is not None:
            self.facility = facility
        if format is not None:
            self.format = format
        if _global is not None:
            self._global = _global
        self.index = index
        if length is not None:
            self.length = length
        if level is not None:
            self.level = level
        if minlevel is not None:
            self.minlevel = minlevel
        if nolog is not None:
            self.nolog = nolog
        if sample_range is not None:
            self.sample_range = sample_range
        if sample_size is not None:
            self.sample_size = sample_size

    @property
    def address(self):
        """Gets the address of this LogTarget.  # noqa: E501


        :return: The address of this LogTarget.  # noqa: E501
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this LogTarget.


        :param address: The address of this LogTarget.  # noqa: E501
        :type: str
        """

        self._address = address

    @property
    def facility(self):
        """Gets the facility of this LogTarget.  # noqa: E501


        :return: The facility of this LogTarget.  # noqa: E501
        :rtype: str
        """
        return self._facility

    @facility.setter
    def facility(self, facility):
        """Sets the facility of this LogTarget.


        :param facility: The facility of this LogTarget.  # noqa: E501
        :type: str
        """
        allowed_values = ["kern", "user", "mail", "daemon", "auth", "syslog", "lpr", "news", "uucp", "cron", "auth2", "ftp", "ntp", "audit", "alert", "cron2", "local0", "local1", "local2", "local3", "local4", "local5", "local6", "local7"]  # noqa: E501
        if facility not in allowed_values:
            raise ValueError(
                "Invalid value for `facility` ({0}), must be one of {1}"  # noqa: E501
                .format(facility, allowed_values)
            )

        self._facility = facility

    @property
    def format(self):
        """Gets the format of this LogTarget.  # noqa: E501


        :return: The format of this LogTarget.  # noqa: E501
        :rtype: str
        """
        return self._format

    @format.setter
    def format(self, format):
        """Sets the format of this LogTarget.


        :param format: The format of this LogTarget.  # noqa: E501
        :type: str
        """
        allowed_values = ["rfc3164", "rfc5424", "short", "raw"]  # noqa: E501
        if format not in allowed_values:
            raise ValueError(
                "Invalid value for `format` ({0}), must be one of {1}"  # noqa: E501
                .format(format, allowed_values)
            )

        self._format = format

    @property
    def _global(self):
        """Gets the _global of this LogTarget.  # noqa: E501


        :return: The _global of this LogTarget.  # noqa: E501
        :rtype: bool
        """
        return self.__global

    @_global.setter
    def _global(self, _global):
        """Sets the _global of this LogTarget.


        :param _global: The _global of this LogTarget.  # noqa: E501
        :type: bool
        """

        self.__global = _global

    @property
    def index(self):
        """Gets the index of this LogTarget.  # noqa: E501


        :return: The index of this LogTarget.  # noqa: E501
        :rtype: int
        """
        return self._index

    @index.setter
    def index(self, index):
        """Sets the index of this LogTarget.


        :param index: The index of this LogTarget.  # noqa: E501
        :type: int
        """
        if index is None:
            raise ValueError("Invalid value for `index`, must not be `None`")  # noqa: E501

        self._index = index

    @property
    def length(self):
        """Gets the length of this LogTarget.  # noqa: E501


        :return: The length of this LogTarget.  # noqa: E501
        :rtype: int
        """
        return self._length

    @length.setter
    def length(self, length):
        """Sets the length of this LogTarget.


        :param length: The length of this LogTarget.  # noqa: E501
        :type: int
        """

        self._length = length

    @property
    def level(self):
        """Gets the level of this LogTarget.  # noqa: E501


        :return: The level of this LogTarget.  # noqa: E501
        :rtype: str
        """
        return self._level

    @level.setter
    def level(self, level):
        """Sets the level of this LogTarget.


        :param level: The level of this LogTarget.  # noqa: E501
        :type: str
        """
        allowed_values = ["emerg", "alert", "crit", "err", "warning", "notice", "info", "debug"]  # noqa: E501
        if level not in allowed_values:
            raise ValueError(
                "Invalid value for `level` ({0}), must be one of {1}"  # noqa: E501
                .format(level, allowed_values)
            )

        self._level = level

    @property
    def minlevel(self):
        """Gets the minlevel of this LogTarget.  # noqa: E501


        :return: The minlevel of this LogTarget.  # noqa: E501
        :rtype: str
        """
        return self._minlevel

    @minlevel.setter
    def minlevel(self, minlevel):
        """Sets the minlevel of this LogTarget.


        :param minlevel: The minlevel of this LogTarget.  # noqa: E501
        :type: str
        """
        allowed_values = ["emerg", "alert", "crit", "err", "warning", "notice", "info", "debug"]  # noqa: E501
        if minlevel not in allowed_values:
            raise ValueError(
                "Invalid value for `minlevel` ({0}), must be one of {1}"  # noqa: E501
                .format(minlevel, allowed_values)
            )

        self._minlevel = minlevel

    @property
    def nolog(self):
        """Gets the nolog of this LogTarget.  # noqa: E501


        :return: The nolog of this LogTarget.  # noqa: E501
        :rtype: bool
        """
        return self._nolog

    @nolog.setter
    def nolog(self, nolog):
        """Sets the nolog of this LogTarget.


        :param nolog: The nolog of this LogTarget.  # noqa: E501
        :type: bool
        """

        self._nolog = nolog

    @property
    def sample_range(self):
        """Gets the sample_range of this LogTarget.  # noqa: E501


        :return: The sample_range of this LogTarget.  # noqa: E501
        :rtype: str
        """
        return self._sample_range

    @sample_range.setter
    def sample_range(self, sample_range):
        """Sets the sample_range of this LogTarget.


        :param sample_range: The sample_range of this LogTarget.  # noqa: E501
        :type: str
        """

        self._sample_range = sample_range

    @property
    def sample_size(self):
        """Gets the sample_size of this LogTarget.  # noqa: E501


        :return: The sample_size of this LogTarget.  # noqa: E501
        :rtype: int
        """
        return self._sample_size

    @sample_size.setter
    def sample_size(self, sample_size):
        """Sets the sample_size of this LogTarget.


        :param sample_size: The sample_size of this LogTarget.  # noqa: E501
        :type: int
        """

        self._sample_size = sample_size

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(LogTarget, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LogTarget):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
