# coding: utf-8

"""
    HAProxy Data Plane API

    API for editing and managing haproxy instances. Provides process information, configuration management, haproxy stats and logs.   # noqa: E501

    OpenAPI spec version: 2.7
    Contact: support@haproxy.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class NativeStat(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'backend_name': 'str',
        'name': 'str',
        'stats': 'NativeStatStats',
        'type': 'str'
    }

    attribute_map = {
        'backend_name': 'backend_name',
        'name': 'name',
        'stats': 'stats',
        'type': 'type'
    }

    def __init__(self, backend_name=None, name=None, stats=None, type=None):  # noqa: E501
        """NativeStat - a model defined in Swagger"""  # noqa: E501
        self._backend_name = None
        self._name = None
        self._stats = None
        self._type = None
        self.discriminator = None
        if backend_name is not None:
            self.backend_name = backend_name
        if name is not None:
            self.name = name
        if stats is not None:
            self.stats = stats
        if type is not None:
            self.type = type

    @property
    def backend_name(self):
        """Gets the backend_name of this NativeStat.  # noqa: E501


        :return: The backend_name of this NativeStat.  # noqa: E501
        :rtype: str
        """
        return self._backend_name

    @backend_name.setter
    def backend_name(self, backend_name):
        """Sets the backend_name of this NativeStat.


        :param backend_name: The backend_name of this NativeStat.  # noqa: E501
        :type: str
        """

        self._backend_name = backend_name

    @property
    def name(self):
        """Gets the name of this NativeStat.  # noqa: E501


        :return: The name of this NativeStat.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this NativeStat.


        :param name: The name of this NativeStat.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def stats(self):
        """Gets the stats of this NativeStat.  # noqa: E501


        :return: The stats of this NativeStat.  # noqa: E501
        :rtype: NativeStatStats
        """
        return self._stats

    @stats.setter
    def stats(self, stats):
        """Sets the stats of this NativeStat.


        :param stats: The stats of this NativeStat.  # noqa: E501
        :type: NativeStatStats
        """

        self._stats = stats

    @property
    def type(self):
        """Gets the type of this NativeStat.  # noqa: E501


        :return: The type of this NativeStat.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this NativeStat.


        :param type: The type of this NativeStat.  # noqa: E501
        :type: str
        """
        allowed_values = ["backend", "server", "frontend"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NativeStat, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NativeStat):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
