# coding: utf-8

"""
    HAProxy Data Plane API

    API for editing and managing haproxy instances. Provides process information, configuration management, haproxy stats and logs.   # noqa: E501

    OpenAPI spec version: 2.7
    Contact: support@haproxy.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Program(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'command': 'str',
        'group': 'str',
        'name': 'str',
        'start_on_reload': 'str',
        'user': 'str'
    }

    attribute_map = {
        'command': 'command',
        'group': 'group',
        'name': 'name',
        'start_on_reload': 'start-on-reload',
        'user': 'user'
    }

    def __init__(self, command=None, group=None, name=None, start_on_reload=None, user=None):  # noqa: E501
        """Program - a model defined in Swagger"""  # noqa: E501
        self._command = None
        self._group = None
        self._name = None
        self._start_on_reload = None
        self._user = None
        self.discriminator = None
        self.command = command
        if group is not None:
            self.group = group
        self.name = name
        if start_on_reload is not None:
            self.start_on_reload = start_on_reload
        if user is not None:
            self.user = user

    @property
    def command(self):
        """Gets the command of this Program.  # noqa: E501

        The command to be run, with flags and options.  # noqa: E501

        :return: The command of this Program.  # noqa: E501
        :rtype: str
        """
        return self._command

    @command.setter
    def command(self, command):
        """Sets the command of this Program.

        The command to be run, with flags and options.  # noqa: E501

        :param command: The command of this Program.  # noqa: E501
        :type: str
        """
        if command is None:
            raise ValueError("Invalid value for `command`, must not be `None`")  # noqa: E501

        self._command = command

    @property
    def group(self):
        """Gets the group of this Program.  # noqa: E501

        The group to run the command as, if different than the HAProxy group.  # noqa: E501

        :return: The group of this Program.  # noqa: E501
        :rtype: str
        """
        return self._group

    @group.setter
    def group(self, group):
        """Sets the group of this Program.

        The group to run the command as, if different than the HAProxy group.  # noqa: E501

        :param group: The group of this Program.  # noqa: E501
        :type: str
        """

        self._group = group

    @property
    def name(self):
        """Gets the name of this Program.  # noqa: E501


        :return: The name of this Program.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Program.


        :param name: The name of this Program.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def start_on_reload(self):
        """Gets the start_on_reload of this Program.  # noqa: E501

        HAProxy stops and recreates child programs at reload.  # noqa: E501

        :return: The start_on_reload of this Program.  # noqa: E501
        :rtype: str
        """
        return self._start_on_reload

    @start_on_reload.setter
    def start_on_reload(self, start_on_reload):
        """Sets the start_on_reload of this Program.

        HAProxy stops and recreates child programs at reload.  # noqa: E501

        :param start_on_reload: The start_on_reload of this Program.  # noqa: E501
        :type: str
        """
        allowed_values = ["enabled", "disabled"]  # noqa: E501
        if start_on_reload not in allowed_values:
            raise ValueError(
                "Invalid value for `start_on_reload` ({0}), must be one of {1}"  # noqa: E501
                .format(start_on_reload, allowed_values)
            )

        self._start_on_reload = start_on_reload

    @property
    def user(self):
        """Gets the user of this Program.  # noqa: E501

        The user to run the command as, if different than the HAProxy user.  # noqa: E501

        :return: The user of this Program.  # noqa: E501
        :rtype: str
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this Program.

        The user to run the command as, if different than the HAProxy user.  # noqa: E501

        :param user: The user of this Program.  # noqa: E501
        :type: str
        """

        self._user = user

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Program, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Program):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
