# coding: utf-8

"""
    HAProxy Data Plane API

    API for editing and managing haproxy instances. Provides process information, configuration management, haproxy stats and logs.   # noqa: E501

    OpenAPI spec version: 2.7
    Contact: support@haproxy.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from dataplaneapi.models.server_params import ServerParams  # noqa: F401,E501

class Server(ServerParams):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'address': 'str',
        'id': 'int',
        'name': 'str',
        'port': 'int'
    }
    if hasattr(ServerParams, "swagger_types"):
        swagger_types.update(ServerParams.swagger_types)

    attribute_map = {
        'address': 'address',
        'id': 'id',
        'name': 'name',
        'port': 'port'
    }
    if hasattr(ServerParams, "attribute_map"):
        attribute_map.update(ServerParams.attribute_map)

    def __init__(self, address=None, id=None, name=None, port=None, *args, **kwargs):  # noqa: E501
        """Server - a model defined in Swagger"""  # noqa: E501
        self._address = None
        self._id = None
        self._name = None
        self._port = None
        self.discriminator = None
        self.address = address
        if id is not None:
            self.id = id
        self.name = name
        if port is not None:
            self.port = port
        ServerParams.__init__(self, *args, **kwargs)

    @property
    def address(self):
        """Gets the address of this Server.  # noqa: E501


        :return: The address of this Server.  # noqa: E501
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this Server.


        :param address: The address of this Server.  # noqa: E501
        :type: str
        """
        if address is None:
            raise ValueError("Invalid value for `address`, must not be `None`")  # noqa: E501

        self._address = address

    @property
    def id(self):
        """Gets the id of this Server.  # noqa: E501


        :return: The id of this Server.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Server.


        :param id: The id of this Server.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this Server.  # noqa: E501


        :return: The name of this Server.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Server.


        :param name: The name of this Server.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def port(self):
        """Gets the port of this Server.  # noqa: E501


        :return: The port of this Server.  # noqa: E501
        :rtype: int
        """
        return self._port

    @port.setter
    def port(self, port):
        """Sets the port of this Server.


        :param port: The port of this Server.  # noqa: E501
        :type: int
        """

        self._port = port

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Server, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Server):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
