# coding: utf-8

"""
    HAProxy Data Plane API

    API for editing and managing haproxy instances. Provides process information, configuration management, haproxy stats and logs.   # noqa: E501

    OpenAPI spec version: 2.7
    Contact: support@haproxy.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Source(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'address': 'str',
        'address_second': 'str',
        'hdr': 'str',
        'interface': 'str',
        'occ': 'str',
        'port': 'int',
        'port_second': 'int',
        'usesrc': 'str'
    }

    attribute_map = {
        'address': 'address',
        'address_second': 'address_second',
        'hdr': 'hdr',
        'interface': 'interface',
        'occ': 'occ',
        'port': 'port',
        'port_second': 'port_second',
        'usesrc': 'usesrc'
    }

    def __init__(self, address=None, address_second=None, hdr=None, interface=None, occ=None, port=None, port_second=None, usesrc=None):  # noqa: E501
        """Source - a model defined in Swagger"""  # noqa: E501
        self._address = None
        self._address_second = None
        self._hdr = None
        self._interface = None
        self._occ = None
        self._port = None
        self._port_second = None
        self._usesrc = None
        self.discriminator = None
        self.address = address
        if address_second is not None:
            self.address_second = address_second
        if hdr is not None:
            self.hdr = hdr
        if interface is not None:
            self.interface = interface
        if occ is not None:
            self.occ = occ
        if port is not None:
            self.port = port
        if port_second is not None:
            self.port_second = port_second
        if usesrc is not None:
            self.usesrc = usesrc

    @property
    def address(self):
        """Gets the address of this Source.  # noqa: E501


        :return: The address of this Source.  # noqa: E501
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this Source.


        :param address: The address of this Source.  # noqa: E501
        :type: str
        """
        if address is None:
            raise ValueError("Invalid value for `address`, must not be `None`")  # noqa: E501

        self._address = address

    @property
    def address_second(self):
        """Gets the address_second of this Source.  # noqa: E501


        :return: The address_second of this Source.  # noqa: E501
        :rtype: str
        """
        return self._address_second

    @address_second.setter
    def address_second(self, address_second):
        """Sets the address_second of this Source.


        :param address_second: The address_second of this Source.  # noqa: E501
        :type: str
        """

        self._address_second = address_second

    @property
    def hdr(self):
        """Gets the hdr of this Source.  # noqa: E501


        :return: The hdr of this Source.  # noqa: E501
        :rtype: str
        """
        return self._hdr

    @hdr.setter
    def hdr(self, hdr):
        """Sets the hdr of this Source.


        :param hdr: The hdr of this Source.  # noqa: E501
        :type: str
        """

        self._hdr = hdr

    @property
    def interface(self):
        """Gets the interface of this Source.  # noqa: E501


        :return: The interface of this Source.  # noqa: E501
        :rtype: str
        """
        return self._interface

    @interface.setter
    def interface(self, interface):
        """Sets the interface of this Source.


        :param interface: The interface of this Source.  # noqa: E501
        :type: str
        """

        self._interface = interface

    @property
    def occ(self):
        """Gets the occ of this Source.  # noqa: E501


        :return: The occ of this Source.  # noqa: E501
        :rtype: str
        """
        return self._occ

    @occ.setter
    def occ(self, occ):
        """Sets the occ of this Source.


        :param occ: The occ of this Source.  # noqa: E501
        :type: str
        """

        self._occ = occ

    @property
    def port(self):
        """Gets the port of this Source.  # noqa: E501


        :return: The port of this Source.  # noqa: E501
        :rtype: int
        """
        return self._port

    @port.setter
    def port(self, port):
        """Sets the port of this Source.


        :param port: The port of this Source.  # noqa: E501
        :type: int
        """

        self._port = port

    @property
    def port_second(self):
        """Gets the port_second of this Source.  # noqa: E501


        :return: The port_second of this Source.  # noqa: E501
        :rtype: int
        """
        return self._port_second

    @port_second.setter
    def port_second(self, port_second):
        """Sets the port_second of this Source.


        :param port_second: The port_second of this Source.  # noqa: E501
        :type: int
        """

        self._port_second = port_second

    @property
    def usesrc(self):
        """Gets the usesrc of this Source.  # noqa: E501


        :return: The usesrc of this Source.  # noqa: E501
        :rtype: str
        """
        return self._usesrc

    @usesrc.setter
    def usesrc(self, usesrc):
        """Sets the usesrc of this Source.


        :param usesrc: The usesrc of this Source.  # noqa: E501
        :type: str
        """
        allowed_values = ["address", "client", "clientip", "hdr_ip"]  # noqa: E501
        if usesrc not in allowed_values:
            raise ValueError(
                "Invalid value for `usesrc` ({0}), must be one of {1}"  # noqa: E501
                .format(usesrc, allowed_values)
            )

        self._usesrc = usesrc

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Source, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Source):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
