# coding: utf-8

"""
    HAProxy Data Plane API

    API for editing and managing haproxy instances. Provides process information, configuration management, haproxy stats and logs.   # noqa: E501

    OpenAPI spec version: 2.7
    Contact: support@haproxy.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class StatsHttpRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cond': 'str',
        'cond_test': 'str',
        'realm': 'str',
        'type': 'str'
    }

    attribute_map = {
        'cond': 'cond',
        'cond_test': 'cond_test',
        'realm': 'realm',
        'type': 'type'
    }

    def __init__(self, cond=None, cond_test=None, realm=None, type=None):  # noqa: E501
        """StatsHttpRequest - a model defined in Swagger"""  # noqa: E501
        self._cond = None
        self._cond_test = None
        self._realm = None
        self._type = None
        self.discriminator = None
        if cond is not None:
            self.cond = cond
        if cond_test is not None:
            self.cond_test = cond_test
        if realm is not None:
            self.realm = realm
        self.type = type

    @property
    def cond(self):
        """Gets the cond of this StatsHttpRequest.  # noqa: E501


        :return: The cond of this StatsHttpRequest.  # noqa: E501
        :rtype: str
        """
        return self._cond

    @cond.setter
    def cond(self, cond):
        """Sets the cond of this StatsHttpRequest.


        :param cond: The cond of this StatsHttpRequest.  # noqa: E501
        :type: str
        """

        self._cond = cond

    @property
    def cond_test(self):
        """Gets the cond_test of this StatsHttpRequest.  # noqa: E501


        :return: The cond_test of this StatsHttpRequest.  # noqa: E501
        :rtype: str
        """
        return self._cond_test

    @cond_test.setter
    def cond_test(self, cond_test):
        """Sets the cond_test of this StatsHttpRequest.


        :param cond_test: The cond_test of this StatsHttpRequest.  # noqa: E501
        :type: str
        """

        self._cond_test = cond_test

    @property
    def realm(self):
        """Gets the realm of this StatsHttpRequest.  # noqa: E501


        :return: The realm of this StatsHttpRequest.  # noqa: E501
        :rtype: str
        """
        return self._realm

    @realm.setter
    def realm(self, realm):
        """Sets the realm of this StatsHttpRequest.


        :param realm: The realm of this StatsHttpRequest.  # noqa: E501
        :type: str
        """

        self._realm = realm

    @property
    def type(self):
        """Gets the type of this StatsHttpRequest.  # noqa: E501


        :return: The type of this StatsHttpRequest.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this StatsHttpRequest.


        :param type: The type of this StatsHttpRequest.  # noqa: E501
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501
        allowed_values = ["allow", "deny", "auth"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(StatsHttpRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StatsHttpRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
