# coding: utf-8

"""
    HAProxy Data Plane API

    API for editing and managing haproxy instances. Provides process information, configuration management, haproxy stats and logs.   # noqa: E501

    OpenAPI spec version: 2.7
    Contact: support@haproxy.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class TcpResponseRule(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'action': 'str',
        'bandwidth_limit_limit': 'str',
        'bandwidth_limit_name': 'str',
        'bandwidth_limit_period': 'str',
        'cond': 'str',
        'cond_test': 'str',
        'expr': 'str',
        'index': 'int',
        'log_level': 'str',
        'lua_action': 'str',
        'lua_params': 'str',
        'mark_value': 'str',
        'nice_value': 'int',
        'sc_id': 'int',
        'sc_int': 'int',
        'spoe_engine': 'str',
        'spoe_group': 'str',
        'timeout': 'int',
        'tos_value': 'str',
        'type': 'str',
        'var_name': 'str',
        'var_scope': 'str'
    }

    attribute_map = {
        'action': 'action',
        'bandwidth_limit_limit': 'bandwidth_limit_limit',
        'bandwidth_limit_name': 'bandwidth_limit_name',
        'bandwidth_limit_period': 'bandwidth_limit_period',
        'cond': 'cond',
        'cond_test': 'cond_test',
        'expr': 'expr',
        'index': 'index',
        'log_level': 'log_level',
        'lua_action': 'lua_action',
        'lua_params': 'lua_params',
        'mark_value': 'mark_value',
        'nice_value': 'nice_value',
        'sc_id': 'sc_id',
        'sc_int': 'sc_int',
        'spoe_engine': 'spoe_engine',
        'spoe_group': 'spoe_group',
        'timeout': 'timeout',
        'tos_value': 'tos_value',
        'type': 'type',
        'var_name': 'var_name',
        'var_scope': 'var_scope'
    }

    def __init__(self, action=None, bandwidth_limit_limit=None, bandwidth_limit_name=None, bandwidth_limit_period=None, cond=None, cond_test=None, expr=None, index=None, log_level=None, lua_action=None, lua_params=None, mark_value=None, nice_value=None, sc_id=None, sc_int=None, spoe_engine=None, spoe_group=None, timeout=None, tos_value=None, type=None, var_name=None, var_scope=None):  # noqa: E501
        """TcpResponseRule - a model defined in Swagger"""  # noqa: E501
        self._action = None
        self._bandwidth_limit_limit = None
        self._bandwidth_limit_name = None
        self._bandwidth_limit_period = None
        self._cond = None
        self._cond_test = None
        self._expr = None
        self._index = None
        self._log_level = None
        self._lua_action = None
        self._lua_params = None
        self._mark_value = None
        self._nice_value = None
        self._sc_id = None
        self._sc_int = None
        self._spoe_engine = None
        self._spoe_group = None
        self._timeout = None
        self._tos_value = None
        self._type = None
        self._var_name = None
        self._var_scope = None
        self.discriminator = None
        if action is not None:
            self.action = action
        if bandwidth_limit_limit is not None:
            self.bandwidth_limit_limit = bandwidth_limit_limit
        if bandwidth_limit_name is not None:
            self.bandwidth_limit_name = bandwidth_limit_name
        if bandwidth_limit_period is not None:
            self.bandwidth_limit_period = bandwidth_limit_period
        if cond is not None:
            self.cond = cond
        if cond_test is not None:
            self.cond_test = cond_test
        if expr is not None:
            self.expr = expr
        self.index = index
        if log_level is not None:
            self.log_level = log_level
        if lua_action is not None:
            self.lua_action = lua_action
        if lua_params is not None:
            self.lua_params = lua_params
        if mark_value is not None:
            self.mark_value = mark_value
        if nice_value is not None:
            self.nice_value = nice_value
        if sc_id is not None:
            self.sc_id = sc_id
        if sc_int is not None:
            self.sc_int = sc_int
        if spoe_engine is not None:
            self.spoe_engine = spoe_engine
        if spoe_group is not None:
            self.spoe_group = spoe_group
        if timeout is not None:
            self.timeout = timeout
        if tos_value is not None:
            self.tos_value = tos_value
        self.type = type
        if var_name is not None:
            self.var_name = var_name
        if var_scope is not None:
            self.var_scope = var_scope

    @property
    def action(self):
        """Gets the action of this TcpResponseRule.  # noqa: E501


        :return: The action of this TcpResponseRule.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this TcpResponseRule.


        :param action: The action of this TcpResponseRule.  # noqa: E501
        :type: str
        """
        allowed_values = ["accept", "reject", "lua", "set-bandwidth-limit", "close", "sc-inc-gpc0", "sc-inc-gpc1", "sc-set-gpt0", "send-spoe-group", "set-log-level", "set-mark", "set-nice", "set-tos", "silent-drop", "unset-var"]  # noqa: E501
        if action not in allowed_values:
            raise ValueError(
                "Invalid value for `action` ({0}), must be one of {1}"  # noqa: E501
                .format(action, allowed_values)
            )

        self._action = action

    @property
    def bandwidth_limit_limit(self):
        """Gets the bandwidth_limit_limit of this TcpResponseRule.  # noqa: E501


        :return: The bandwidth_limit_limit of this TcpResponseRule.  # noqa: E501
        :rtype: str
        """
        return self._bandwidth_limit_limit

    @bandwidth_limit_limit.setter
    def bandwidth_limit_limit(self, bandwidth_limit_limit):
        """Sets the bandwidth_limit_limit of this TcpResponseRule.


        :param bandwidth_limit_limit: The bandwidth_limit_limit of this TcpResponseRule.  # noqa: E501
        :type: str
        """

        self._bandwidth_limit_limit = bandwidth_limit_limit

    @property
    def bandwidth_limit_name(self):
        """Gets the bandwidth_limit_name of this TcpResponseRule.  # noqa: E501


        :return: The bandwidth_limit_name of this TcpResponseRule.  # noqa: E501
        :rtype: str
        """
        return self._bandwidth_limit_name

    @bandwidth_limit_name.setter
    def bandwidth_limit_name(self, bandwidth_limit_name):
        """Sets the bandwidth_limit_name of this TcpResponseRule.


        :param bandwidth_limit_name: The bandwidth_limit_name of this TcpResponseRule.  # noqa: E501
        :type: str
        """

        self._bandwidth_limit_name = bandwidth_limit_name

    @property
    def bandwidth_limit_period(self):
        """Gets the bandwidth_limit_period of this TcpResponseRule.  # noqa: E501


        :return: The bandwidth_limit_period of this TcpResponseRule.  # noqa: E501
        :rtype: str
        """
        return self._bandwidth_limit_period

    @bandwidth_limit_period.setter
    def bandwidth_limit_period(self, bandwidth_limit_period):
        """Sets the bandwidth_limit_period of this TcpResponseRule.


        :param bandwidth_limit_period: The bandwidth_limit_period of this TcpResponseRule.  # noqa: E501
        :type: str
        """

        self._bandwidth_limit_period = bandwidth_limit_period

    @property
    def cond(self):
        """Gets the cond of this TcpResponseRule.  # noqa: E501


        :return: The cond of this TcpResponseRule.  # noqa: E501
        :rtype: str
        """
        return self._cond

    @cond.setter
    def cond(self, cond):
        """Sets the cond of this TcpResponseRule.


        :param cond: The cond of this TcpResponseRule.  # noqa: E501
        :type: str
        """
        allowed_values = ["if", "unless"]  # noqa: E501
        if cond not in allowed_values:
            raise ValueError(
                "Invalid value for `cond` ({0}), must be one of {1}"  # noqa: E501
                .format(cond, allowed_values)
            )

        self._cond = cond

    @property
    def cond_test(self):
        """Gets the cond_test of this TcpResponseRule.  # noqa: E501


        :return: The cond_test of this TcpResponseRule.  # noqa: E501
        :rtype: str
        """
        return self._cond_test

    @cond_test.setter
    def cond_test(self, cond_test):
        """Sets the cond_test of this TcpResponseRule.


        :param cond_test: The cond_test of this TcpResponseRule.  # noqa: E501
        :type: str
        """

        self._cond_test = cond_test

    @property
    def expr(self):
        """Gets the expr of this TcpResponseRule.  # noqa: E501


        :return: The expr of this TcpResponseRule.  # noqa: E501
        :rtype: str
        """
        return self._expr

    @expr.setter
    def expr(self, expr):
        """Sets the expr of this TcpResponseRule.


        :param expr: The expr of this TcpResponseRule.  # noqa: E501
        :type: str
        """

        self._expr = expr

    @property
    def index(self):
        """Gets the index of this TcpResponseRule.  # noqa: E501


        :return: The index of this TcpResponseRule.  # noqa: E501
        :rtype: int
        """
        return self._index

    @index.setter
    def index(self, index):
        """Sets the index of this TcpResponseRule.


        :param index: The index of this TcpResponseRule.  # noqa: E501
        :type: int
        """
        if index is None:
            raise ValueError("Invalid value for `index`, must not be `None`")  # noqa: E501

        self._index = index

    @property
    def log_level(self):
        """Gets the log_level of this TcpResponseRule.  # noqa: E501


        :return: The log_level of this TcpResponseRule.  # noqa: E501
        :rtype: str
        """
        return self._log_level

    @log_level.setter
    def log_level(self, log_level):
        """Sets the log_level of this TcpResponseRule.


        :param log_level: The log_level of this TcpResponseRule.  # noqa: E501
        :type: str
        """
        allowed_values = ["emerg", "alert", "crit", "err", "warning", "notice", "info", "debug", "silent"]  # noqa: E501
        if log_level not in allowed_values:
            raise ValueError(
                "Invalid value for `log_level` ({0}), must be one of {1}"  # noqa: E501
                .format(log_level, allowed_values)
            )

        self._log_level = log_level

    @property
    def lua_action(self):
        """Gets the lua_action of this TcpResponseRule.  # noqa: E501


        :return: The lua_action of this TcpResponseRule.  # noqa: E501
        :rtype: str
        """
        return self._lua_action

    @lua_action.setter
    def lua_action(self, lua_action):
        """Sets the lua_action of this TcpResponseRule.


        :param lua_action: The lua_action of this TcpResponseRule.  # noqa: E501
        :type: str
        """

        self._lua_action = lua_action

    @property
    def lua_params(self):
        """Gets the lua_params of this TcpResponseRule.  # noqa: E501


        :return: The lua_params of this TcpResponseRule.  # noqa: E501
        :rtype: str
        """
        return self._lua_params

    @lua_params.setter
    def lua_params(self, lua_params):
        """Sets the lua_params of this TcpResponseRule.


        :param lua_params: The lua_params of this TcpResponseRule.  # noqa: E501
        :type: str
        """

        self._lua_params = lua_params

    @property
    def mark_value(self):
        """Gets the mark_value of this TcpResponseRule.  # noqa: E501


        :return: The mark_value of this TcpResponseRule.  # noqa: E501
        :rtype: str
        """
        return self._mark_value

    @mark_value.setter
    def mark_value(self, mark_value):
        """Sets the mark_value of this TcpResponseRule.


        :param mark_value: The mark_value of this TcpResponseRule.  # noqa: E501
        :type: str
        """

        self._mark_value = mark_value

    @property
    def nice_value(self):
        """Gets the nice_value of this TcpResponseRule.  # noqa: E501


        :return: The nice_value of this TcpResponseRule.  # noqa: E501
        :rtype: int
        """
        return self._nice_value

    @nice_value.setter
    def nice_value(self, nice_value):
        """Sets the nice_value of this TcpResponseRule.


        :param nice_value: The nice_value of this TcpResponseRule.  # noqa: E501
        :type: int
        """

        self._nice_value = nice_value

    @property
    def sc_id(self):
        """Gets the sc_id of this TcpResponseRule.  # noqa: E501


        :return: The sc_id of this TcpResponseRule.  # noqa: E501
        :rtype: int
        """
        return self._sc_id

    @sc_id.setter
    def sc_id(self, sc_id):
        """Sets the sc_id of this TcpResponseRule.


        :param sc_id: The sc_id of this TcpResponseRule.  # noqa: E501
        :type: int
        """

        self._sc_id = sc_id

    @property
    def sc_int(self):
        """Gets the sc_int of this TcpResponseRule.  # noqa: E501


        :return: The sc_int of this TcpResponseRule.  # noqa: E501
        :rtype: int
        """
        return self._sc_int

    @sc_int.setter
    def sc_int(self, sc_int):
        """Sets the sc_int of this TcpResponseRule.


        :param sc_int: The sc_int of this TcpResponseRule.  # noqa: E501
        :type: int
        """

        self._sc_int = sc_int

    @property
    def spoe_engine(self):
        """Gets the spoe_engine of this TcpResponseRule.  # noqa: E501


        :return: The spoe_engine of this TcpResponseRule.  # noqa: E501
        :rtype: str
        """
        return self._spoe_engine

    @spoe_engine.setter
    def spoe_engine(self, spoe_engine):
        """Sets the spoe_engine of this TcpResponseRule.


        :param spoe_engine: The spoe_engine of this TcpResponseRule.  # noqa: E501
        :type: str
        """

        self._spoe_engine = spoe_engine

    @property
    def spoe_group(self):
        """Gets the spoe_group of this TcpResponseRule.  # noqa: E501


        :return: The spoe_group of this TcpResponseRule.  # noqa: E501
        :rtype: str
        """
        return self._spoe_group

    @spoe_group.setter
    def spoe_group(self, spoe_group):
        """Sets the spoe_group of this TcpResponseRule.


        :param spoe_group: The spoe_group of this TcpResponseRule.  # noqa: E501
        :type: str
        """

        self._spoe_group = spoe_group

    @property
    def timeout(self):
        """Gets the timeout of this TcpResponseRule.  # noqa: E501


        :return: The timeout of this TcpResponseRule.  # noqa: E501
        :rtype: int
        """
        return self._timeout

    @timeout.setter
    def timeout(self, timeout):
        """Sets the timeout of this TcpResponseRule.


        :param timeout: The timeout of this TcpResponseRule.  # noqa: E501
        :type: int
        """

        self._timeout = timeout

    @property
    def tos_value(self):
        """Gets the tos_value of this TcpResponseRule.  # noqa: E501


        :return: The tos_value of this TcpResponseRule.  # noqa: E501
        :rtype: str
        """
        return self._tos_value

    @tos_value.setter
    def tos_value(self, tos_value):
        """Sets the tos_value of this TcpResponseRule.


        :param tos_value: The tos_value of this TcpResponseRule.  # noqa: E501
        :type: str
        """

        self._tos_value = tos_value

    @property
    def type(self):
        """Gets the type of this TcpResponseRule.  # noqa: E501


        :return: The type of this TcpResponseRule.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this TcpResponseRule.


        :param type: The type of this TcpResponseRule.  # noqa: E501
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501
        allowed_values = ["content", "inspect-delay"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def var_name(self):
        """Gets the var_name of this TcpResponseRule.  # noqa: E501


        :return: The var_name of this TcpResponseRule.  # noqa: E501
        :rtype: str
        """
        return self._var_name

    @var_name.setter
    def var_name(self, var_name):
        """Sets the var_name of this TcpResponseRule.


        :param var_name: The var_name of this TcpResponseRule.  # noqa: E501
        :type: str
        """

        self._var_name = var_name

    @property
    def var_scope(self):
        """Gets the var_scope of this TcpResponseRule.  # noqa: E501


        :return: The var_scope of this TcpResponseRule.  # noqa: E501
        :rtype: str
        """
        return self._var_scope

    @var_scope.setter
    def var_scope(self, var_scope):
        """Sets the var_scope of this TcpResponseRule.


        :param var_scope: The var_scope of this TcpResponseRule.  # noqa: E501
        :type: str
        """

        self._var_scope = var_scope

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TcpResponseRule, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TcpResponseRule):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
